#!/www/python/bin/python

from optik import OptionParser, Option, OptionValueError, SUPPRESS_USAGE
from optik.errors import OptionError

__revision__ = "$Id: test_choice.py,v 1.2 2002/06/21 20:15:29 gward Exp $"

# Test the "choice" Option type (new with Optik 1.4)

parser = OptionParser(usage=SUPPRESS_USAGE)
parser.add_option("-c", action="store", type="choice", dest="choice",
                  choices=["one", "two", "three"])
(values, args) = parser.parse_args(["-c", "one", "xyz"])
assert len(vars(values)) == 1
assert values.choice == "one"
assert args == ["xyz"]
print "ok: 1"

try:
    parser.parse_args(["-c", "four", "abc"])
except SystemExit, err:
    assert err.args[0].endswith("option -c: invalid choice: 'four' "
                                "(choose from 'one', 'two', 'three')"), \
           err.args[0]
    print "ok: 2"
else:
    print "not ok"

parser.add_option("-d", "--default", choices=["four", "five", "six"])
opt = parser.get_option("-d")
assert opt.type == "choice"
assert opt.action == "store"
print "ok: 3"

try:
    parser.add_option("-b", "--bad", type="choice")
except OptionError, err:
    assert str(err) == ("option -b/--bad: must supply a list of choices for "
                        "type 'choice'"), str(err)
    print "ok: 4"
else:
    print "not ok"

try:
    parser.add_option("-b", "--bad", type="choice", choices="bad choices")
except OptionError, err:
    assert str(err) == ("option -b/--bad: choices must be a list of strings "
                        "('str' supplied)"), str(err)
    print "ok: 5"
else:
    print "not ok"
